
/* PAIRLIST 1.2 */

#include "pairlist.h"

static TP_PAIR ListElemCreate(void)

   {TP_PAIR pl;
    pl = malloc(sizeof(T_PAIR));
    if (pl != NULL)
       {pl->Next = NULL;
	pl->Name[0] = '\0';
	pl->Value[0] = '\0';}
    return pl;
   }


int ListCreate(T_LIST *listdesc)

   {if (listdesc != NULL)
       {listdesc->Head = ListElemCreate();
	if (listdesc->Head != NULL)
	   {listdesc->NElem = 0;
	    listdesc->Current = NULL;
	    return 1;}
	else
	    return 0;
       }
    else return 0;
   }


static void ListGetFront(T_LIST *listdesc)

   {if (listdesc != NULL)
       {TP_PAIR newhp;
	newhp = listdesc->Head->Next;
	if (newhp != NULL)
	   {free(listdesc->Head);
	    listdesc->Head = newhp;
	    listdesc->NElem--;}
       }
   }


void ListFree(T_LIST *listdesc)

   {if (listdesc != NULL)
       {if (listdesc->NElem > 0)
	   {int i;
	    for( i=0 ; i<listdesc->NElem ; i++)
		ListGetFront(listdesc);
	   }
	free(listdesc->Head);
	listdesc->Head = NULL;
	listdesc->NElem = 0;
	listdesc->Current = NULL;
       }
   }


char *ListRead(T_LIST *listdesc, char *name)

   {if (listdesc != NULL)
       {listdesc->Current = listdesc->Head;
	while ((strcmp(listdesc->Current->Name, name)) && (listdesc->Current->Name[0] != '\0'))
	    listdesc->Current = listdesc->Current->Next;
	if (listdesc->Current->Name[0] != '\0')
	    return listdesc->Current->Value;
	else
	    return NULL;
       }
    else return NULL;
   }


int ListPutFront(T_LIST *listdesc, char *name, char *value)

   {if (listdesc != NULL)
	{TP_PAIR newp;
	 newp = ListElemCreate();
	 if (newp != NULL)
	    {newp->Next = listdesc->Head;
	     strncpy(newp->Name, name, MAX_NAME-1);
	     strncpy(newp->Value, value, MAX_VALUE-1);
	     listdesc->Head = newp;
	     listdesc->NElem++;
	     return 1;}
	 else return 0;
	}
    else return 0;
   }


int ListIsEmpty(T_LIST *listdesc)

   {if (listdesc == NULL)
	return 1;
    else if (listdesc->NElem == 0)
	return 1;
    else return 0;
   }
